org.apache.hc.core5.annotation

## Enum ThreadingBehavior

- java.lang.Object
- - java.lang.Enum<ThreadingBehavior>
  - - org.apache.hc.core5.annotation.ThreadingBehavior

- All Implemented Interfaces:
    Serializable, Comparable<ThreadingBehavior>

      public enum ThreadingBehavior
      extends Enum<ThreadingBehavior>

  Defines types of threading behavior enforced at runtime.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `IMMUTABLE` Instances of classes with the given contract are expected to be fully immutable and thread-safe.
    `IMMUTABLE_CONDITIONAL` Instances of classes with the given contract are expected to be immutable if their dependencies injected at construction time are immutable and are expected to be thread-safe if their dependencies are thread-safe.
    `SAFE` Instances of classes with the given contract are expected to be fully thread-safe.
    `SAFE_CONDITIONAL` Instances of classes with the given contract are expected to be thread-safe if their dependencies injected at construction time are thread-safe.
    `STATELESS` Instances of classes with the given contract are expected to maintain no state and to be thread-safe.
    `UNSAFE` Instances of classes with the given contract are expected to be non thread-safe.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ThreadingBehavior` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ThreadingBehavior[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### IMMUTABLE

          public static final ThreadingBehavior IMMUTABLE

      Instances of classes with the given contract are expected to be fully immutable and thread-safe.

    - #### IMMUTABLE_CONDITIONAL

          public static final ThreadingBehavior IMMUTABLE_CONDITIONAL

      Instances of classes with the given contract are expected to be immutable if their dependencies injected at construction time are immutable and are expected to be thread-safe if their dependencies are thread-safe.

    - #### STATELESS

          public static final ThreadingBehavior STATELESS

      Instances of classes with the given contract are expected to maintain no state and to be thread-safe.

    - #### SAFE

          public static final ThreadingBehavior SAFE

      Instances of classes with the given contract are expected to be fully thread-safe.

    - #### SAFE_CONDITIONAL

          public static final ThreadingBehavior SAFE_CONDITIONAL

      Instances of classes with the given contract are expected to be thread-safe if their dependencies injected at construction time are thread-safe.

    - #### UNSAFE

          public static final ThreadingBehavior UNSAFE

      Instances of classes with the given contract are expected to be non thread-safe.

  - ### Method Detail

    - #### values

          public static ThreadingBehavior[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ThreadingBehavior c : ThreadingBehavior.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ThreadingBehavior valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.